org.apache.lucene.search.spans

## Class SpanMultiTermQueryWrapper<Q extends MultiTermQuery>

- java.lang.Object
- - org.apache.lucene.search.Query
  - - org.apache.lucene.search.spans.SpanQuery
    - - org.apache.lucene.search.spans.SpanMultiTermQueryWrapper<Q>

    public class SpanMultiTermQueryWrapper<Q extends MultiTermQuery>
    extends SpanQuery

Wraps any `MultiTermQuery` as a `SpanQuery`, so it can be nested within other SpanQuery classes.

The query is rewritten by default to a `SpanOrQuery` containing the expanded terms, but this can be customized.

Example:

>      WildcardQuery wildcard = new WildcardQuery(new Term("field", "bro?n"));
>      SpanQuery spanWildcard = new SpanMultiTermQueryWrapper<WildcardQuery>(wildcard);
>      // do something with spanWildcard, such as use it in a SpanFirstQuery

### Nested Class Summary

Nested Classes
`static class` `SpanMultiTermQueryWrapper.SpanRewriteMethod` Abstract class that defines how the query is rewritten.
`static class` `SpanMultiTermQueryWrapper.TopTermsSpanBooleanQueryRewrite` A rewrite method that first translates each term into a SpanTermQuery in a `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, and keeps the scores as computed by the query.

### Field Summary

Fields
`protected Q` `query`
`static SpanMultiTermQueryWrapper.SpanRewriteMethod` `SCORING_SPAN_QUERY_REWRITE` A rewrite method that first translates each term into a SpanTermQuery in a `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, and keeps the scores as computed by the query.

### Constructor Summary

Constructors
Constructor and Description
`SpanMultiTermQueryWrapper(Q query)` Create a new SpanMultiTermQueryWrapper.

### Method Summary

All Methods Instance Methods Concrete Methods
`SpanWeight` `createWeight(IndexSearcher searcher, ScoreMode scoreMode, float boost)` Expert: Constructs an appropriate Weight implementation for this query.
`boolean` `equals(Object other)` Override and implement query instance equivalence properly in a subclass.
`String` `getField()` Returns the name of the field matched by this query.
`SpanMultiTermQueryWrapper.SpanRewriteMethod` `getRewriteMethod()` Expert: returns the rewriteMethod
`Query` `getWrappedQuery()` Returns the wrapped query
`int` `hashCode()` Override and implement query hash code properly in a subclass.
`Query` `rewrite(IndexReader reader)` Expert: called to re-write queries into primitive queries.
`void` `setRewriteMethod(SpanMultiTermQueryWrapper.SpanRewriteMethod rewriteMethod)` Expert: sets the rewrite method.
`String` `toString(String field)` Prints a query to a string, with `field` assumed to be the default field and omitted.
`void` `visit(QueryVisitor visitor)` Recurse through the query tree, visiting any child queries

### Methods inherited from class org.apache.lucene.search.spans.SpanQuery

`getTermStates, getTermStates`

### Methods inherited from class org.apache.lucene.search.Query

`classHash, sameClassAs, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### query

    protected final Q extends MultiTermQuery query

#### SCORING_SPAN_QUERY_REWRITE

    public static final SpanMultiTermQueryWrapper.SpanRewriteMethod SCORING_SPAN_QUERY_REWRITE

A rewrite method that first translates each term into a SpanTermQuery in a `BooleanClause.Occur.SHOULD` clause in a BooleanQuery, and keeps the scores as computed by the query.

See Also:
  `setRewriteMethod(org.apache.lucene.search.spans.SpanMultiTermQueryWrapper.SpanRewriteMethod)`

### Constructor Detail

#### SpanMultiTermQueryWrapper

    public SpanMultiTermQueryWrapper(Q query)

Create a new SpanMultiTermQueryWrapper.

Parameters:
  `query` - Query to wrap.

### Method Detail

#### getRewriteMethod

    public final SpanMultiTermQueryWrapper.SpanRewriteMethod getRewriteMethod()

Expert: returns the rewriteMethod

#### setRewriteMethod

    public final void setRewriteMethod(SpanMultiTermQueryWrapper.SpanRewriteMethod rewriteMethod)

Expert: sets the rewrite method. This only makes sense to be a span rewrite method.

#### getField

    public String getField()

Description copied from class: `SpanQuery`
Returns the name of the field matched by this query.

Specified by:
  `getField` in class `SpanQuery`

#### createWeight

    public SpanWeight createWeight(IndexSearcher searcher,
                                   ScoreMode scoreMode,
                                   float boost)
                            throws IOException

Description copied from class: `Query`
Expert: Constructs an appropriate Weight implementation for this query.

Only implemented by primitive queries, which re-write to themselves.

Specified by:
  `createWeight` in class `SpanQuery`
  `scoreMode` - How the produced scorers will be consumed.
  `boost` - The boost that is propagated by the parent queries.
Throws:
  `IOException`

#### getWrappedQuery

    public Query getWrappedQuery()

Returns the wrapped query

#### toString

    public String toString(String field)

Description copied from class: `Query`
Prints a query to a string, with `field` assumed to be the default field and omitted.

Specified by:
  `toString` in class `Query`

#### rewrite

    public Query rewrite(IndexReader reader)
                  throws IOException

Description copied from class: `Query`
Expert: called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys.

Overrides:
  `rewrite` in class `Query`
Throws:
  `IOException`

#### visit

    public void visit(QueryVisitor visitor)

Description copied from class: `Query`
Recurse through the query tree, visiting any child queries

Overrides:
  `visit` in class `Query`
Parameters:
  `visitor` - a QueryVisitor to be called by each query in the tree

#### hashCode

    public int hashCode()

Description copied from class: `Query`
Override and implement query hash code properly in a subclass. This is required so that `QueryCache` works properly.

Specified by:
  `hashCode` in class `Query`
See Also:
  `Query.equals(Object)`

#### equals

    public boolean equals(Object other)

Description copied from class: `Query`
Override and implement query instance equivalence properly in a subclass. This is required so that `QueryCache` works properly. Typically a query will be equal to another only if it's an instance of the same class and its document-filtering properties are identical that other instance. Utility methods are provided for certain repetitive code.

Specified by:
  `equals` in class `Query`
See Also:
  `Query.sameClassAs(Object)`, `Query.classHash()`